Attribute VB_Name = "Module1"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit

Private Declare Function NetShareEnum Lib "netapi32.dll" ( _
    ByVal servername As Long, _
    ByVal level As Long, _
    ByVal bufptr As Long, _
    ByVal prefmaxlen As Long, _
    ByRef entriesread As Long, _
    ByRef totalentries As Long, _
    ByRef resume_handle As Long _
    ) As Long
    
Private Declare Function NetApiBufferFree Lib "netapi32.dll" ( _
    ByVal buffer As Long) As Long
    
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias _
    "RtlMoveMemory" (destination As Any, source As Any, _
    ByVal length As Long)
    
Private Declare Function lstrlenW Lib "kernel32.dll" ( _
    ByVal strptr As Long) As Long

Public Type tShare
    Name As String
    Typ As Long
    Beschreibung As String
End Type

Public Function ErmittleShares(ByVal Server As String, Shares() As tShare) As _
    Boolean
    Dim Gelesen As Long
    Dim Puffer As Long
    Dim Resultat As Long
    Dim ResumeHandle As Long
    Dim Total As Long
    Dim i As Long
    
    ' HINWEIS: Da wir fr prefmaxlen den Wert -1 verwenden,
    ' berichtet uns die Funktion NetShareEnum wirklich alles.
    ' Aus diesem Grund ist zum einen die Variable Gelesen
    ' gleich der Variablen Total, ebenso ist ResumeHandle un-
    ' ntig, da diese nur verwendet wird, um bei zu kleinem
    ' Puffer spter an der gleichen Stelle weiterzumachen,
    ' an der man aufgehrt hat.
    
    Resultat = NetShareEnum(strptr(Server), 1, VarPtr(Puffer), -1, _
        Gelesen, Total, ResumeHandle)
        
'   Resultat = NetShareEnum(strptr(Server), 1, Puffer, -1, Gelesen, Total, _
        ResumeHandle)
    
    Debug.Print Resultat
    
    If Resultat = 0 And Gelesen > 0 Then
        ReDim Shares(0 To Gelesen - 1)
        For i = 0 To Gelesen - 1
            With Shares(i)
    ' Hinweis: Aus irgendeinem Grund sind selbst die Long-Variablen
    ' in der Rckgabestruktur nur Pointer, sodass wir diese ber die
    ' Funktion Dereferenz_Long dereferenzieren mssen. Bei den
    ' Strings mssen wir dann gleich zwei Dereferenzierungen durch-
    ' fhren: Einmal, um den Pointer zu dem Long-Wert, der als Poin-
    ' ter fr den String dient, zu dereferenzieren, und dann, um
    ' diesen Long-Wert wieder zu dereferenzieren und einen String zu
    ' erhalten.
    ' Die Variable Puffer liefert uns einen Pointer auf ein Array
    ' von SHARE_INFO_1-Strukturen. Dieses besteht aus drei Long-
    ' Werten, damit ist eine Struktur 12 Byte gro. Wir springen
    ' deshalb auch jedesmal 12 Byte weiter.
                .Name = Dereferenz_String(Dereferenz_Long(Puffer + 12 * i))
                .Typ = Dereferenz_Long(Puffer + 12 * i + 4)
                .Beschreibung = Dereferenz_String(Dereferenz_Long(Puffer + 12 _
                    * i + 8))
            End With
        Next i
        
        ErmittleShares = True
    End If
    
    ' Falls NetShareEnum Speicher belegt hat, muss dieser wieder freigegeben
    ' werden
    If CBool(Puffer) Then
       NetApiBufferFree Puffer
    End If
End Function

' Dereferenzierung eines Pointer auf einen Long
Private Function Dereferenz_Long(ByVal Pointer As Long) As Long
    Call CopyMemory(Dereferenz_Long, ByVal Pointer, 4)
End Function

' Dereferenzierung eines Pointers auf einen String
Private Function Dereferenz_String(ByVal Pointer As Long) As String
    Dim Laenge As Long
    Dim Puffer() As Byte
    
    If CBool(Pointer) Then
        Laenge = lstrlenW(Pointer) * 2
        If CBool(Laenge) Then
            ReDim Puffer(Laenge - 1) As Byte
            CopyMemory Puffer(0), ByVal Pointer, Laenge
            Dereferenz_String = Puffer
        End If
    End If
End Function
